import 'package:flutter/material.dart';
import 'package:ionicons/ionicons.dart';

import 'package:scrobbles/common/ui/pages/discoveries.dart';
import 'package:scrobbles/common/ui/pages/home.dart';
import 'package:scrobbles/common/ui/pages/statistics.dart';

class ActivityPageItem {
  final String code;
  final Icon icon;
  final Widget page;

  const ActivityPageItem({
    required this.code,
    required this.icon,
    required this.page,
  });
}

class ActivityPage {
  static const bool displayBottomNavBar = false;

  static const indexHome = 0;
  static const pageHome = ActivityPageItem(
    code: 'page_home',
    icon: Icon(Ionicons.home_outline),
    page: PageHome(),
  );

  static const indexDiscoveries = 1;
  static const pageDiscoveries = ActivityPageItem(
    code: 'page_discoveries',
    icon: Icon(Ionicons.star_outline),
    page: PageDiscoveries(),
  );

  static const indexStatistics = 2;
  static const pageStatistics = ActivityPageItem(
    code: 'page_statistics',
    icon: Icon(Ionicons.bar_chart_outline),
    page: PageStatistics(),
  );

  static Map<int, ActivityPageItem> items = {
    indexHome: pageHome,
    indexDiscoveries: pageDiscoveries,
    indexStatistics: pageStatistics,
  };

  static int defaultPageIndex = indexHome;

  static bool isIndexAllowed(int pageIndex) {
    return items.keys.contains(pageIndex);
  }

  static Widget getWidget(int pageIndex) {
    return items[pageIndex]?.page ?? pageHome.page;
  }
}
